﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'ByteStreamReader Class
Private Sub Class_Globals
	Private internalInputStream As InputStream
	Private internalByteBuffer As ByteBuffer
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(inStream As InputStream)
	internalInputStream = inStream
	internalByteBuffer.Initialize(-1)
	internalByteBuffer.Allocate(internalByteBuffer.LONG_SIZE)
	internalByteBuffer.Order = internalByteBuffer.LITTLE_ENDIAN
End Sub

Public Sub Close
	internalInputStream.Close
	internalByteBuffer.Clear
End Sub

Public Sub ReadBoolean As Boolean
	Dim buffer() As Byte
	buffer = ReadBytes(1)
	If buffer(0) = 0 Then
		Return False
	Else
		Return True
	End If
End Sub

Public Sub ReadBitmap() As Bitmap
	Dim resultBitmap As Bitmap
	Dim neededLength As Int = ReadInt
	Dim buffer() As Byte = ReadBytes(neededLength)
	Dim memoryInputStream As InputStream
	memoryInputStream.InitializeFromBytesArray(buffer, 0, buffer.Length)
	resultBitmap.Initialize2(memoryInputStream)
	memoryInputStream.Close
	Return resultBitmap
End Sub

Public Sub ReadBuffer(buffer() As Byte) As Int
	Return internalInputStream.ReadBytes(buffer, 0, buffer.Length)
End Sub

Public Sub ReadBuffer2(buffer() As Byte, count As Int) As Int
	Return internalInputStream.ReadBytes(buffer, 0, count)
End Sub

Public Sub ReadBuffer3(buffer() As Byte, offset As Int, count As Int) As Int
	Return internalInputStream.ReadBytes(buffer, offset, count)
End Sub

Public Sub ReadBytes(count As Int) As Byte()
	Dim buffer(count) As Byte
	If ReadBuffer(buffer) < buffer.Length Then
		Dim exception As ExceptionEx
		exception.Initialize("Not enough bytes could be readed!")
		exception.Throw
	End If
	Return buffer
End Sub

Public Sub ReadDouble As Double
	Dim buffer() As Byte
	buffer = ReadBytes(internalByteBuffer.DOUBLE_SIZE)
	internalByteBuffer.Position = 0
	internalByteBuffer.PutBuffer(buffer)
	Return internalByteBuffer.GetDouble2(0)
End Sub

Public Sub ReadFloat As Float
	Dim buffer() As Byte
	buffer = ReadBytes(internalByteBuffer.FLOAT_SIZE)
	internalByteBuffer.Position = 0
	internalByteBuffer.PutBuffer(buffer)
	Return internalByteBuffer.GetFloat2(0)
End Sub

Public Sub ReadInt As Int
	Dim buffer() As Byte
	buffer = ReadBytes(internalByteBuffer.INT_SIZE)
	internalByteBuffer.Position = 0
	internalByteBuffer.PutBuffer(buffer)
	Return internalByteBuffer.GetInt2(0)
End Sub

Public Sub ReadLong As Long
	Dim buffer() As Byte
	buffer = ReadBytes(internalByteBuffer.LONG_SIZE)
	internalByteBuffer.Position = 0
	internalByteBuffer.PutBuffer(buffer)
	Return internalByteBuffer.GetLong2(0)
End Sub

Public Sub ReadString As String
	Dim resultString As String = ""
	Dim count As Int
	count = ReadInt
	If count > 0 Then
		Dim buffer() As Byte
		buffer = ReadBytes(count)
		resultString = BytesToString(buffer, 0, buffer.Length, "UTF-8")
	Else if count < 0 Then
		Log("WARNING - ByteStreamReader->ReadString has read a negativ string count of " & count & " bytes!")
	End If
	Return resultString
End Sub