﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'ContactAddress Class module
Private Sub Class_Globals
	Private internalCity As String = ""
	Private internalCountry As String = ""
	Private internalFormatted As String = ""
	Private internalLabel As String = ""
	Private internalNeighborhood As String = ""
	Private internalPOBox As String = ""
	Private internalPostcode As String = ""
	Private internalRegion As String = ""
	Private internalStreet As String = ""
	Private internalTyp As String = ""
End Sub

'This will intialize this contact address entry with the default typ(e).
Public Sub Initialize
	internalTyp = ContactStatics.AddressTypes.Get("1")
End Sub

'This will get/set the city name.
Public Sub getCity As String
	Return internalCity
End Sub

Public Sub setCity(city As String)
	internalCity = city
End Sub

Public Sub Clear
	internalCity = ""
	internalCountry = ""
	internalFormatted = ""
	internalLabel = ""
	internalNeighborhood = ""
	internalPOBox = ""
	internalPostcode = ""
	internalRegion = ""
	internalStreet = ""
	internalTyp = ContactStatics.AddressTypes.Get("1")
End Sub

'This will get/set the country name.
Public Sub getCountry As String
	Return internalCountry
End Sub

Public Sub setCountry(country As String)
	internalCountry = country
End Sub

'This will get/set the right formatted address.
'- Not tested yet. Do it only use for getting, on set it will be ignored.
'- Android will fill up this field automaticly after set to the contact.
Public Sub getFormatted As String
	Return internalFormatted
End Sub

Public Sub setFormatted(formatted As String)
	internalFormatted = formatted
End Sub

'This will get/set the label of this entry. By default this field is null or empty.
'- The typ(e) of this entry must be set to custom to use the label.
Public Sub getLabel As String
	Return internalLabel
End Sub

Public Sub setLabel(label As String)
	internalLabel = label
End Sub

'This will get/set the neighborhood name.
Public Sub getNeighborhood As String
	Return internalNeighborhood
End Sub

Public Sub setNeighborhood(neighborhood As String)
	internalNeighborhood = neighborhood
End Sub

'This is for internal use only!
Private Sub Parse(data() As Object)
	internalFormatted = data(0)
	internalTyp = ContactStatics.AddressTypes.Get(data(1))
	internalLabel = data(2)
	internalStreet = data(3)
	internalPOBox = data(4)
	internalNeighborhood = data(5)
	internalCity = data(6)
	internalRegion = data(7)
	internalPostcode = data(8)
	internalCountry = data(9)
End Sub

'This will get/set the pobox.
Public Sub getPOBox As String
	Return internalPOBox
End Sub

Public Sub setPOBox(pobox As String)
	internalPOBox = pobox
End Sub

'This will get/set the postcode as string.
Public Sub getPostcode As String
	Return internalPostcode
End Sub

Public Sub setPostcode(postcode As String)
	internalPostcode = postcode
End Sub

'This will get/set the region name.
Public Sub getRegion As String
	Return internalRegion
End Sub

Public Sub setRegion(region As String)
	internalRegion = region
End Sub

'This will get/set the street name.
Public Sub getStreet As String
	Return internalStreet
End Sub

Public Sub setStreet(street As String)
	internalStreet = street
End Sub

'This is for internal use only!
Private Sub ToDataArray As Object()
	Dim data(10) As Object
	data(0) = internalFormatted
	data(1) = ContactStatics.GetKeyFromValue(ContactStatics.AddressTypes, internalTyp, "1")
	data(2) = internalLabel
	data(3) = internalStreet
	data(4) = internalPOBox
	data(5) = internalNeighborhood
	data(6) = internalCity
	data(7) = internalRegion
	data(8) = internalPostcode
	data(9) = internalCountry
	Return data
End Sub

'This will get/set the typ(e) of this entry.
'- On custom typ(e) the label must be filled up.
'- Valid types for this field can be found in ContactStatics.AddressTypes map.
Public Sub getTyp As String
	Return internalTyp
End Sub

Public Sub setTyp(typ As String)
	Dim typeExists As Boolean = ContactStatics.HasValue(ContactStatics.AddressTypes, typ)
	If typeExists Then
		internalTyp = typ.ToLowerCase
	Else
		LogColor("ContactAddress->Typ: The type '" & typ & "' was unknown by this class!", Colors.Red)
	End If
End Sub

Private Sub ReadFrom(reader As ByteStreamReader)
	Dim data(10) As Object
	data(0) = reader.ReadString
	data(1) = "" & reader.ReadInt
	For index = 2 To data.Length - 1
		data(index) = reader.ReadString
	Next
	Parse(data)
End Sub

Private Sub WriteTo(writer As ByteStreamWriter)
	Dim data() As Object = ToDataArray
	writer.WriteString(data(0))
	writer.WriteInt(data(1))
	For index = 2 To data.Length - 1
		writer.WriteString(data(index))
	Next
End Sub