﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'ContactEmailAddress Class module
Private Sub Class_Globals
	Private internalAddress As String
	Private internalLabel As String
	Private internalTyp As String
	Private internalIsPrimary As Boolean
End Sub

'This will initialize this email address entry with the default typ(e).
Public Sub Initialize
	Clear
	'internalTyp = ContactStatics.EmailAddressTypes.Get("3")
End Sub

'This will get/set the email address.
Public Sub getAddress As String
	Return internalAddress
End Sub

Public Sub setAddress(address As String)
	internalAddress = address
End Sub

'This will clear this class structure.
Public Sub Clear
	internalAddress = ""
	internalIsPrimary = False
	internalLabel = ""
	internalTyp = ContactStatics.EmailAddressTypes.Get("3")
End Sub

'This will return true if this email entry was the primary one of the contact, otherwise false will be returned.
Public Sub getIsPrimary As Boolean
	Return internalIsPrimary
End Sub

'This will get/set the label. By default it is empty or null.
'- if you will use your on label, set the typ(e) of this entry to custom. 
Public Sub getLabel As String
	Return internalLabel
End Sub

Public Sub setLabel(label As String)
	internalLabel = label
End Sub

'For internal use only.
Private Sub Parse(data() As Object, primary As Boolean)
	internalAddress = data(0)
	internalTyp = ContactStatics.EmailAddressTypes.Get(data(1))
	internalLabel = data(2)
	internalIsPrimary = primary
End Sub

'For internal use only.
Private Sub ToDataArray As Object()
	Dim data(3) As Object
	data(0) = internalAddress
	data(1) = ContactStatics.GetKeyFromValue(ContactStatics.EmailAddressTypes, internalTyp, "3")
	data(2) = internalLabel
	Return data
End Sub

'This will get/set the typ(e) of this email address entry.
'- The valid types can be found in the ContactStatics.EmailAddressTypes map.
'- The type custom should be used in combination with the label.
Public Sub getTyp As String
	Return internalTyp
End Sub

Public Sub setTyp(typ As String)
	Dim typeExists As Boolean = ContactStatics.HasValue(ContactStatics.EmailAddressTypes, typ)
	If typeExists Then
		internalTyp = typ.ToLowerCase
	Else
		LogColor("ContactEMailAddress->Typ: The type '" & typ & "' was unknown by this class!", Colors.Red)
	End If
End Sub

Private Sub ReadFrom(reader As ByteStreamReader)
	Dim isPrimary As Boolean
	Dim data(3) As Object
	data(0) = reader.ReadString
	data(1) = "" & reader.ReadInt
	data(2) = reader.ReadString
	isPrimary = reader.ReadBoolean
	Parse(data, isPrimary) 
End Sub

Private Sub WriteTo(writer As ByteStreamWriter)
	Dim data() As Object = ToDataArray
	writer.WriteString(data(0))
	writer.WriteInt(data(1))
	writer.WriteString(data(2))
	writer.WriteBoolean(internalIsPrimary)
End Sub