﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'ContactEvent Class module
Private Sub Class_Globals
	Private internalLabel As String
	Private internalStartDate As String
	Private internalTyp As String
End Sub

'This will initialize this contact event entry with the default typ(e).
Public Sub Initialize
	Clear
	'internalTyp = ContactStatics.EventTypes.Get("3")
End Sub

Public Sub Clear
	internalLabel = ""
	internalStartDate = ""
	internalTyp = ContactStatics.EventTypes.Get("3")
End Sub

'This will get/set the label of this event entry. By default this is null or empty.
'- the typ(e) must be set to custom to use the label in a correct way.
Public Sub getLabel As String
	Return internalLabel
End Sub

Public Sub setLabel(label As String)
	internalLabel = label
End Sub

'This is for internal use only!
Private Sub Parse(data() As Object)
	internalStartDate = data(0)
	internalTyp = ContactStatics.EventTypes.Get(data(1))
	internalLabel = data(2)
End Sub

'This will get/set the start date of the event.
Public Sub getStartDate As String
	Return internalStartDate
End Sub

Public Sub setStartDate(startDate As String)
	internalStartDate = startDate
End Sub

'This is for internal use only!
Private Sub ToDataArray As Object()
	Dim data(3) As Object
	data(0) = internalStartDate
	data(1) = ContactStatics.GetKeyFromValue(ContactStatics.EventTypes, internalTyp, "3")
	data(2) = internalLabel
	Return data
End Sub

'This will get/set the typ(e) of this event.
'- The label field must be filled up on the custom type.
Public Sub getTyp As String
	Return internalTyp
End Sub

Public Sub setTyp(typ As String)
	Dim typeExists As Boolean = ContactStatics.HasValue(ContactStatics.EventTypes, typ)
	If typeExists Then
		internalTyp = typ.ToLowerCase
	Else
		LogColor("ContactEvent->Typ: The type '" & typ & "' was unknown by this class!", Colors.Red)
	End If
End Sub

'For internal use only
Private Sub ReadFrom(reader As ByteStreamReader)
	Dim data(3) As Object
	data(0) = reader.ReadString
	data(1) = "" & reader.ReadInt
	data(2) = reader.ReadString
	Parse(data)
End Sub

'For internal use only
Private Sub WriteTo(writer As ByteStreamWriter)
	Dim data() As Object = ToDataArray
	writer.WriteString(data(0))
	writer.WriteInt(data(1))
	writer.WriteString(data(2))
End Sub