﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'ContactIM Class module
Private Sub Class_Globals
	Private internalCustomProtocol As String
	Private internalData As String
	Private internalLabel As String
	Private internalProtocol As String
	Private internalTyp As String
End Sub

'This will initialize this contact im (= Instant Messanger) class object with the default typ(e).
Public Sub Initialize
	Clear
	'internalTyp = ContactStatics.IMTypes.Get("1") 'default typ(e) value
End Sub

Public Sub Clear
	internalCustomProtocol = ""
	internalData = ""
	internalLabel = ""
	internalProtocol = ContactStatics.IMProtocols.Get("3")
	internalTyp = ContactStatics.IMTypes.Get("1")
End Sub

'This will get/set the custom protocol. Protocol must be set to custom!
'By default this field is null or empty string.
Public Sub getCustomProtocol As String
	Return internalCustomProtocol
End Sub

Public Sub setCustomProtocol(protocol As String)
	internalCustomProtocol = protocol
End Sub

'This will get/set the data of the im.
Public Sub getData As String
	Return internalData
End Sub

Public Sub setData(data As String)
	internalData = data
End Sub

'This will get/set the label. The typ(e) must be set to custom value for a correct use.
'- By default this field is null or empty string.
Public Sub getLabel As String
	Return internalLabel
End Sub

Public Sub setLabel(label As String)
	internalLabel = label
End Sub

'This is for internal use only! Use it with safty.
Private Sub Parse(data() As Object)
	internalData = data(0)
	internalTyp = ContactStatics.IMTypes.Get(data(1))
	internalLabel = data(2)
	internalProtocol = ContactStatics.IMProtocols.Get(data(3))
	internalCustomProtocol = data(4)
End Sub

'This will get/set the im protocol.
'- Valid values can be found in ContactStatics.IMProtocols map.
'- Set this field to custom to use the customprotocol field.
Public Sub getProtocol As String
	Return internalProtocol
End Sub

Public Sub setProtocol(protocol As String)
	Dim protocolExists As Boolean = ContactStatics.HasValue(ContactStatics.IMProtocols, protocol)
	If protocolExists Then
		internalProtocol = protocol.ToLowerCase
	Else
		LogColor("ContactIM->Protocol: The instant messanger protocol '" & protocol & "' was unknown by this class!", Colors.Red)
	End If
End Sub

'This is for internal use only!
Private Sub ToDataArray As Object()
	Dim data(5) As Object
	data(0) = internalData
	data(1) = ContactStatics.GetKeyFromValue(ContactStatics.IMTypes, internalTyp, "1")
	data(2) = internalLabel
	data(3) = ContactStatics.GetKeyFromValue(ContactStatics.IMProtocols, internalProtocol, "3")
	data(4) = internalCustomProtocol
	Return data
End Sub

'This will get/set the typ(e) of this im entry.
'- Valid types can be found in ContactStatics.IMTypes map.
'- Set it to custom to set a own label.
Public Sub getTyp As String
	Return internalTyp
End Sub

Public Sub setTyp(typ As String)
	Dim typeExists As Boolean = ContactStatics.HasValue(ContactStatics.IMTypes, typ)
	If typeExists Then
		internalTyp = typ.ToLowerCase
	Else
		LogColor("ContactIM->Typ: The type '" & typ & "' was unknown by this class!", Colors.Red)
	End If
End Sub

Private Sub ReadFrom(reader As ByteStreamReader)
	Dim data(5) As Object
	data(0) = reader.ReadString
	data(1) = "" & reader.ReadInt
	data(2) = reader.ReadString
	data(3) = "" & reader.ReadInt
	data(4) = reader.ReadString
	Parse(data)
End Sub

Private Sub WriteTo(writer As ByteStreamWriter)
	Dim data() As Object = ToDataArray
	writer.WriteString(data(0))
	writer.WriteInt(data(1))
	writer.WriteString(data(2))
	writer.WriteInt(data(3))
	writer.WriteString(data(4))
End Sub