﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'ContactItem Class module
'This class can't be named contact, it was reserved by the phone library and can get problems
'when you use it together. So this class was renamed to contactitem for now.
Private Sub Class_Globals
	Private internalContactHandler As ContactHandler
	Private internalID As Long
End Sub

'This is for internal use by the contactbook class only!!!
Public Sub Initialize(id As Long, displayName As String, handler As ContactHandler)
	internalID = id
	'internalDisplayName = displayName 'For now this is ignored
	internalContactHandler = handler
End Sub

'This will add a sturctured postal (address) entry to the contact.
' - For now the formatted property of the address will be ignored.
Public Sub AddAddress(address As ContactAddress) As Boolean
	Dim addressData() As Object = GetDataObjects(address)'address.ToDataArray
	addressData(0) = Null 'Set the formatted data to null, this will be set by the system. FOR TESTING
	Return internalContactHandler.SetData(internalID, ContactMimeTypes.STRUCTURED_POSTAL, addressData, False)
End Sub

'This will add an email address entry to the contact.
Public Sub AddEmailAddress(emailAddress As ContactEmailAddress) As Boolean
	Return internalContactHandler.SetData(internalID, ContactMimeTypes.EMAIL, GetDataObjects(emailAddress), False)
End Sub

'This will add an email address entry to the contact without to fillout the contactamailaddress class.
Public Sub AddEmailAddressSimple(emailAddress As String, typeValue As String) As Boolean
	Dim typeKey As Int = ContactStatics.GetKeyFromValue(ContactStatics.WebsiteTypes, typeValue, 1)
	Return internalContactHandler.SetData(internalID, ContactMimeTypes.EMAIL, Array As Object(emailAddress, typeKey), True)
End Sub

'EXPERIMENTAL! This will add a entry type like ContactAddress, ... to this contact item.
'Without ContactStructuredName, Note and ThumbnailPhoto.
Public Sub AddEntry(entry As Object) As Boolean
	Dim resultAdded As Boolean = False
	Dim mimeType As String = DetermineEntryMimeType(entry)
	If mimeType.Length > 0 Then
		Dim data() As Object = GetDataObjects(entry)
		If data <> Null And data.Length > 0 Then
			resultAdded = internalContactHandler.SetData(internalID, mimeType, data, False)
		End If
	End If
	Return resultAdded
End Sub

'This will add an event entry to the contact.
Public Sub AddEvent(event As ContactEvent) As Boolean
	Return internalContactHandler.SetData(internalID, ContactMimeTypes.EVENT, GetDataObjects(event), False)
End Sub

'This will add an InstantMessanger entry to the contact.
Public Sub AddIM(im As ContactIM) As Boolean
	Return internalContactHandler.SetData(internalID, ContactMimeTypes.IM, GetDataObjects(im), False)
End Sub

'This will add an nickname entry to the contact.
Public Sub AddNickname(nickname As ContactNickname) As Boolean
	Return internalContactHandler.SetData(internalID, ContactMimeTypes.NICKNAME, GetDataObjects(nickname), False)
End Sub

'This will add an organization entry to the contact.
Public Sub AddOrganization(organization As ContactOrganization) As Boolean
	Return internalContactHandler.SetData(internalID, ContactMimeTypes.ORGANIZATION, GetDataObjects(organization), False)
End Sub

'This will add an phone number entry to the contact.
Public Sub AddPhoneNumber(phoneNumber As ContactPhoneNumber) As Boolean
	Return internalContactHandler.SetData(internalID, ContactMimeTypes.PHONE, GetDataObjects(phoneNumber), False)
End Sub

'This will add a phone number entry to the contact without to use the contactphonenumber class.
'phoneNumber - should be a phone number as string
'typeValue - should be one of the phone number types you will find in ContactStatics.PhoneNumberTypes map or empty for default type.
Public Sub AddPhoneNumberSimple(phoneNumber As String, typeValue As String) As Boolean
	Dim typeKey As Int
	typeKey = ContactStatics.GetKeyFromValue(ContactStatics.PhoneNumberTypes, typeValue, 1)
	Return internalContactHandler.SetData(internalID, ContactMimeTypes.PHONE, Array As Object(phoneNumber, typeKey), False)
End Sub

'This will add a relation entry to this contact.
Public Sub AddRelation(relation As ContactRelation) As Boolean
	Return internalContactHandler.SetData(internalID, ContactMimeTypes.RELATION, GetDataObjects(relation), False)
End Sub

'This will add a sip address entry to this contact.
Public Sub AddSipAddress(sipAddress As ContactSipAddress) As Boolean
	Return internalContactHandler.SetData(internalID, ContactMimeTypes.SIP_ADDRESS, GetDataObjects(sipAddress), False)
End Sub

'This will add a website entry to this contact.
Public Sub AddWebsite(website As ContactWebsite) As Boolean
	Return internalContactHandler.SetData(internalID, ContactMimeTypes.WEBSITE, GetDataObjects(website), False)
End Sub

'This will add a website entry to this contact without the use of contactwebsite class.
Public Sub AddWebsiteSimple(url As String, typeValue As String) As Boolean
	Dim typeKey As Int = ContactStatics.GetKeyFromValue(ContactStatics.WebsiteTypes, typeValue, 1)
	Return internalContactHandler.SetData(internalID, ContactMimeTypes.WEBSITE, Array As Object(url, typeKey), True)
End Sub

'This will get all structured postal entrys of this contact and return it as contactaddress class array.
Public Sub getAddresses As ContactAddress()
	Dim structuredPostalData As List
	structuredPostalData = internalContactHandler.GetData(internalID, ContactMimeTypes.STRUCTURED_POSTAL, internalContactHandler.CreateDataArray(10), Null)
	Dim addresses(structuredPostalData.Size) As ContactAddress
	For index = 0 To structuredPostalData.Size - 1
		Dim address As ContactAddress
		address.Initialize
		'address.Parse(structuredPostalData.Get(index))
		ParseIntoEntryObject(address, structuredPostalData.Get(index))
		addresses(index) = address
	Next
	structuredPostalData.Clear
	Return addresses
End Sub

'This will delete this contact from the device!
'- You can also use ContactBook.Remove(contactItem) to delete this contact.
Public Sub Delete
	internalContactHandler.DeleteContact(internalID)
End Sub

'This will get/set the display name of this contact.
Public Sub getDisplayName As String
	Dim nameData As List = internalContactHandler.GetData(internalID, ContactMimeTypes.NAME, Array As String("data1"), Null)
	Dim resultDisplayName As String
	Dim data() As Object = nameData.Get(0)
	resultDisplayName = data(0)
	Return resultDisplayName
End Sub

Public Sub setDisplayName(displayName As String)
	internalContactHandler.UpdateData(internalID, ContactMimeTypes.NAME, Array As Object(displayName), False)
End Sub

'This will get all email address entrys of this contact and return them as contactemailaddress class array.
Public Sub getEMailAddresses As ContactEmailAddress()
	Dim emailAddressData As List
	emailAddressData = internalContactHandler.GetData(internalID, ContactMimeTypes.EMAIL, internalContactHandler.CreateDataArray(3), Null)
	Dim emailAddresses(emailAddressData.Size) As ContactEmailAddress
	For index = 0 To emailAddressData.Size - 1
		Dim data() As Object = emailAddressData.Get(index)
		Dim primary As Boolean = internalContactHandler.GetPrimary(internalID, ContactMimeTypes.EMAIL, data)
		Dim emailAddress As ContactEmailAddress
		emailAddress.Initialize
		ParseIntoEntryObject2(emailAddress, data, primary)'emailAddress.Parse(data, primary)
		emailAddresses(index) = emailAddress
	Next
	emailAddressData.Clear
	Return emailAddresses
End Sub

'This will get all event entrys of this contact and return them as contactevent class array.
Public Sub getEvents As ContactEvent()
	Dim eventsData As List
	eventsData = internalContactHandler.GetData(internalID, ContactMimeTypes.EVENT, internalContactHandler.CreateDataArray(3), Null)
	Dim events(eventsData.Size) As ContactEvent
	For index = 0 To eventsData.Size - 1
		Dim event As ContactEvent
		event.Initialize
		ParseIntoEntryObject(event, eventsData.Get(index))'event.Parse(eventsData.Get(index))
		events(index) = event
	Next
	eventsData.Clear
	Return events
End Sub

Private Sub DetermineEntryMimeType(entry As Object) As String
	Dim resultMimeType As String = ""
	If entry Is ContactAddress Then
		resultMimeType = ContactMimeTypes.STRUCTURED_POSTAL
	Else If entry Is ContactEmailAddress Then
		resultMimeType = ContactMimeTypes.EMAIL
	Else If entry Is ContactEvent Then
		resultMimeType = ContactMimeTypes.EVENT
	Else If entry Is ContactIM Then
		resultMimeType = ContactMimeTypes.IM
	Else If entry Is ContactNickname Then
		resultMimeType = ContactMimeTypes.NICKNAME
	Else If entry Is ContactOrganization Then
		resultMimeType = ContactMimeTypes.ORGANIZATION
	Else If entry Is ContactPhoneNumber Then
		resultMimeType = ContactMimeTypes.PHONE
	Else If entry Is ContactRelation Then
		resultMimeType = ContactMimeTypes.RELATION
	Else If entry Is ContactSipAddress Then
		resultMimeType = ContactMimeTypes.SIP_ADDRESS
	Else If entry Is ContactWebsite Then
		resultMimeType = ContactMimeTypes.WEBSITE
	Else
		LogColor("The entry object is unknown!", Colors.Red)
	End If
	Return resultMimeType
End Sub

'Experimental function to test if a entry was added or removed.
'This will return the number of found entries or -1 if the entry is unknown!
Public Sub HasEntry(entry As Object) As Int
	Dim foundCount As Int = -1
	Dim mimeType As String = DetermineEntryMimeType(entry)
	If mimeType.Length > 0 Then
		Dim data() As Object = GetDataObjects(entry)
		foundCount = 0
		If data <> Null And data.Length > 0 Then
			Dim resultList As List
			resultList = internalContactHandler.GetData(internalID, mimeType, data, Null)
			If resultList.IsInitialized Then
				foundCount = resultList.Size
				resultList.Clear
			End If
		End If
	End If
	Return foundCount
End Sub

'This will get the display photo of the contact, otherwise an uninitialized bitmap will be returned.
Public Sub GetFullSizePhoto As Bitmap
	Dim resultBitmap As Bitmap
	Dim photoUri As String = internalContactHandler.GetPhotoUri(internalID)
	If photoUri.Length > 0 Then
		Dim jObject As JavaObject
		jObject.InitializeStatic("anywheresoftware.b4a.objects.streams.File")
		Dim photoInputStream As InputStream = File.OpenInput(jObject.GetField("ContentDir"), photoUri)
		resultBitmap.Initialize2(photoInputStream)
		photoInputStream.Close
	End If
	Return resultBitmap
End Sub

'This will get a snapshot of this contactitem class object.
'- All known entrys will be requested and stored into a new ContactItemSnapshot class instance.
'- Without the fullsizephoto
Public Sub GetSnapshot As ContactItemSnapshot
	Dim resultSnapshot As ContactItemSnapshot
	resultSnapshot.Initialize
	resultSnapshot.TakeSnapshotFrom(Me)
	Return resultSnapshot 
End Sub

'This will return the contact ID.
Public Sub getID As Long
	Return internalID
End Sub

'This will get all instant messanger entrys of this contact and return them as contactim class array.
Public Sub getIMs As ContactIM()
	Dim imsData As List
	imsData = internalContactHandler.GetData(internalID, ContactMimeTypes.IM, internalContactHandler.CreateDataArray(6), Null)
	Dim ims(imsData.Size) As ContactIM
	For index = 0 To imsData.Size - 1
		Dim im As ContactIM
		im.Initialize
		ParseIntoEntryObject(im, imsData.Get(index))'im.Parse(imsData.Get(index))
		ims(index) = im
	Next
	imsData.Clear
	Return ims
End Sub

'This will get all nickname entrys of this contact and return them as contactnickname class array.
Public Sub getNicknames As ContactNickname()
	Dim nicknamesData As List
	nicknamesData = internalContactHandler.GetData(internalID, ContactMimeTypes.NICKNAME, internalContactHandler.CreateDataArray(3), Null)
	Dim nicknames(nicknamesData.Size) As ContactNickname
	For index = 0 To nicknamesData.Size - 1
		Dim nickname As ContactNickname
		nickname.Initialize
		ParseIntoEntryObject(nickname, nicknamesData.Get(index))'nickname.Parse(nicknamesData.Get(index))
		nicknames(index) = nickname
	Next
	nicknamesData.Clear
	Return nicknames
End Sub

'This will get/set the contacts note.
Public Sub getNote As String
	Dim resultNote As String = ""
	Dim noteData As List
	noteData = internalContactHandler.GetData(internalID, ContactMimeTypes.NOTE, Array As String("data1"), Null)
	If noteData.Size > 0 Then
		Dim data() As Object = noteData.Get(0)
		resultNote = data(0)
	End If
	noteData.Clear
	Return resultNote
End Sub

Public Sub setNote(note As String)
	internalContactHandler.SetData(internalID, ContactMimeTypes.NOTE, Array As Object(note), False)
End Sub

'This will get all organization entrys of the contact and return them as contactorganization class array.
Public Sub getOrganizations As ContactOrganization()
	Dim organizationsData As List
	organizationsData = internalContactHandler.GetData(internalID, ContactMimeTypes.ORGANIZATION, internalContactHandler.CreateDataArray(10), Null)
	Dim organizations(organizationsData.Size) As ContactOrganization
	For index = 0 To organizationsData.Size - 1
		Dim organization As ContactOrganization
		organization.Initialize
		ParseIntoEntryObject(organization, organizationsData.Get(index))'organization.Parse(organizationsData.Get(index))
		organizations(index) = organization
	Next
	organizationsData.Clear
	Return organizations
End Sub

'This will get all phonenumber entrys of this contact and return them as contactphonenumber class array.
Public Sub getPhoneNumbers As ContactPhoneNumber()
	Dim phoneData As List
	phoneData = internalContactHandler.GetData(internalID, ContactMimeTypes.PHONE, internalContactHandler.CreateDataArray(3), Null)
	Dim phoneNumbers(phoneData.Size) As ContactPhoneNumber
	For index = 0 To phoneData.Size - 1
		Dim data() As Object = phoneData.Get(index)
		Dim primary As Boolean = internalContactHandler.GetPrimary(internalID, ContactMimeTypes.PHONE, data)
		Dim phoneNumber As ContactPhoneNumber
		phoneNumber.Initialize
		ParseIntoEntryObject2(phoneNumber, data, primary)'phoneNumber.Parse(data, primary)
		phoneNumbers(index) = phoneNumber
	Next
	phoneData.Clear
	Return phoneNumbers
End Sub

'This will get all relation entrys of this contact and return them as contactrelation class array.
Public Sub getRelations As ContactRelation()
	Dim relationsData As List
	relationsData = internalContactHandler.GetData(internalID, ContactMimeTypes.RELATION, internalContactHandler.CreateDataArray(3), Null)
	Dim relations(relationsData.Size) As ContactRelation
	For index = 0 To relationsData.Size - 1
		Dim relation As ContactRelation
		relation.Initialize
		ParseIntoEntryObject(relation, relationsData.Get(index))'relation.Parse(relationsData.Get(index))
		relations(index) = relation
	Next
	relationsData.Clear
	Return relations
End Sub

'This will remove the given sturctured postal (address) entry from the contact.
'address = should be an exact entry of this contact as ContactAddress class object.
Public Sub RemoveAddress(address As ContactAddress)
	internalContactHandler.DeleteData(internalID, ContactMimeTypes.STRUCTURED_POSTAL, GetDataObjects(address), False)
End Sub

'This will remove the given email address entry from the contact.
'emailAddress = should be an exact entry of this contact as ContactEmailAddress class object.
Public Sub RemoveEmailAddress(emailAddress As ContactEmailAddress)
	internalContactHandler.DeleteData(internalID, ContactMimeTypes.EMAIL, GetDataObjects(emailAddress), False)
End Sub

'EXPERIMENTAL! This will remove the given entry from this contact item.
Public Sub RemoveEntry(entry As Object)
	Dim mimeType As String = DetermineEntryMimeType(entry)
	If mimeType.Length > 0 Then
		Dim data() As Object = GetDataObjects(entry)
		If data <> Null And data.Length > 0 Then
			internalContactHandler.DeleteData(internalID, mimeType, data, False)
		End If
	End If
End Sub

'This will remove the given event entry form the contact.
'event - should be an exact entry of this contact as ContactEvent
Public Sub RemoveEvent(event As ContactEvent)
	internalContactHandler.DeleteData(internalID, ContactMimeTypes.EVENT, GetDataObjects(event), False)
End Sub

'This will remove the given intant messanger entry from this contact.
'im - should be an exact entry of this contact as ContactIM
Public Sub RemoveIM(im As ContactIM)
	internalContactHandler.DeleteData(internalID, ContactMimeTypes.IM, GetDataObjects(im), False)
End Sub

'This will remove the given nickname entry from this contact.
Public Sub RemoveNickname(nickname As ContactNickname)
	internalContactHandler.DeleteData(internalID, ContactMimeTypes.NICKNAME, GetDataObjects(nickname), False)
End Sub

'This will completly remove the note entry from this contact. !!! NOT TESTED YET!!!
Public Sub RemoveNote
	internalContactHandler.DeleteData(internalID, ContactMimeTypes.NOTE, Null, False)
End Sub

'This will remove the given organization entry from this contact.
Public Sub RemoveOrganization(organization As ContactOrganization)
	internalContactHandler.DeleteData(internalID, ContactMimeTypes.ORGANIZATION, GetDataObjects(organization), False)
End Sub

'This will remove the given phoneNumber exact from this contact.
Public Sub RemovePhoneNumber(phoneNumber As ContactPhoneNumber)
	internalContactHandler.DeleteData(internalID, ContactMimeTypes.PHONE, GetDataObjects(phoneNumber), False)
End Sub

'This will remove the given relation entry from this contact
Public Sub RemoveRelation(relation As ContactRelation)
	internalContactHandler.DeleteData(internalID, ContactMimeTypes.RELATION, GetDataObjects(relation), False)
End Sub

'This will remove the given sipaddress entry from this contact.
Public Sub RemoveSipAddress(sipAddress As ContactSipAddress)
	internalContactHandler.DeleteData(internalID, ContactMimeTypes.SIP_ADDRESS, GetDataObjects(sipAddress), False)
End Sub

'This will remove the thumbnail photo from this contact.
Public Sub RemoveThumbnailPhoto
	internalContactHandler.DeleteData(internalID, ContactMimeTypes.PHOTO, Null, False)
End Sub

Public Sub RemoveWebsite(website As ContactWebsite)
	internalContactHandler.DeleteData(internalID, ContactMimeTypes.WEBSITE, GetDataObjects(website), False)
End Sub

'This will set the given email address entry as primary email address of this contact.
'emailAddress - should be an email address entry of this contact as ContactEmailAddress.
Public Sub SetPrimaryEmailAddress(emailAddress As ContactEmailAddress)
	internalContactHandler.SetPrimary(internalID, ContactMimeTypes.EMAIL, GetDataObjects(emailAddress), True)
End Sub

'This will set the given phone number entry as primary phone number of this contact.
'phoneNumber - should be an phone number entry of this contact as ContactPhoneNumber.
Public Sub SetPrimaryPhoneNumber(phoneNumber As ContactPhoneNumber)
	internalContactHandler.SetPrimary(internalID, ContactMimeTypes.PHONE, GetDataObjects(phoneNumber), True)
End Sub

'This will get all sipaddress entrys of this contact and return them as contactsipaddress array.
Public Sub getSipAddresses As ContactSipAddress()
	Dim sipAddressesData As List
	sipAddressesData = internalContactHandler.GetData(internalID, ContactMimeTypes.SIP_ADDRESS, internalContactHandler.CreateDataArray(3), Null)
	Dim sipAddresses(sipAddressesData.Size) As ContactSipAddress
	For index = 0 To sipAddressesData.Size - 1
		Dim sipAddress As ContactSipAddress
		sipAddress.Initialize
		ParseIntoEntryObject(sipAddress, sipAddressesData.Get(index)) 'sipAddress.Parse(sipAddressesData.Get(index))
		sipAddresses(index) = sipAddress
	Next
	sipAddressesData.Clear
	Return sipAddresses
End Sub

'This will get/set the starred state of this contactitem.
Public Sub getStarred As Boolean
	Return internalContactHandler.GetStarred(internalID)
End Sub

Public Sub setStarred(starred As Boolean)
	internalContactHandler.SetStarred(internalID, starred)
End Sub

'This will get/set the structured name of this contactitem.
'A valid ContactStructuredName class will be returned/needed.
Public Sub getStructuredName As ContactStructuredName
	Dim structuredNameData As List
	structuredNameData = internalContactHandler.GetData(internalID, ContactMimeTypes.NAME, internalContactHandler.CreateDataArray(10), Null)
	Dim structuredName As ContactStructuredName
	structuredName.Initialize
	ParseIntoEntryObject(structuredName, structuredNameData.Get(0))'structuredName.Parse(structuredNameData.Get(0))
	structuredNameData.Clear
	Return structuredName
End Sub

Public Sub setStructuredName(structuredName As ContactStructuredName)
	internalContactHandler.UpdateData(internalID, ContactMimeTypes.NAME, GetDataObjects(structuredName), False)
End Sub

'This will get/set the thumbnail photo of this contactitem.
'On GET - If no thumbnail photo was found an uninitialized bitmap will be returned.
'On SET - The bitmap should have the right dimensions or smaller, otherwise it should be resized to the max dimensions.
'On SET - An uninitialized bitmap or null will remove the contacts thumbnail photo.
Public Sub getThumbnailPhoto As Bitmap
	Dim photoData As List
	photoData = internalContactHandler.GetData(internalID, ContactMimeTypes.PHOTO, Array As String("data15"), _
												Array As Boolean(True))
	Dim thumbnailPhoto As Bitmap
	If photoData.Size > 0 Then
		For index = 0 To photoData.Size - 1
			Dim data() As Object = photoData.Get(index)
			Dim buffer() As Byte = data(0)
			If buffer <> Null Then
				Dim memoryInputStream As InputStream
				memoryInputStream.InitializeFromBytesArray(buffer, 0, buffer.Length)
				thumbnailPhoto.Initialize2(memoryInputStream)
				memoryInputStream.Close
				Exit
			End If
		Next
	End If
	photoData.Clear
	Return thumbnailPhoto
End Sub

Public Sub setThumbnailPhoto(thumbnailPhoto As Bitmap)
	If thumbnailPhoto <> Null And thumbnailPhoto.IsInitialized Then
		internalContactHandler.SetThumbnailPhoto(internalID, thumbnailPhoto)
	Else
		RemoveThumbnailPhoto
	End If
End Sub

'This will get the website entrys of this contact and return them as contactwebsite class array.
Public Sub getWebsites As ContactWebsite()
	Dim websiteData As List
	websiteData = internalContactHandler.GetData(internalID, ContactMimeTypes.WEBSITE, internalContactHandler.CreateDataArray(3), Null)
	Dim websites(websiteData.Size) As ContactWebsite
	For index = 0 To websiteData.Size - 1
		Dim website As ContactWebsite
		website.Initialize
		ParseIntoEntryObject(website, websiteData.Get(index)) 'website.Parse(websiteData.Get(index))
		websites(index) = website
	Next
	websiteData.Clear
	Return websites
End Sub

'Helper function to call protected function that was for library internal use only.
Private Sub GetDataObjects(contactEntryObject As Object) As Object()
	Return CallSub(contactEntryObject, "ToDataArray")
End Sub

'Helper function to call protected function that was for library internal use only.
Private Sub ParseIntoEntryObject(contactEntryObject As Object, data() As Object)
	CallSub2(contactEntryObject, "Parse", data)
End Sub

'Helper function to call protected function that was for library internal use only.
Private Sub ParseIntoEntryObject2(contactEntryObject As Object, data() As Object, primary As Boolean)
	CallSub3(contactEntryObject, "Parse", data, primary)
End Sub