﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'ContactItemSnapshot class
Private Sub Class_Globals
	'Private internalContactItem As ContactItem
	
	Private internalAddresses(0) As ContactAddress
	Private internalEMailAddresses(0) As ContactEmailAddress
	Private internalEvents(0) As ContactEvent
	Private internalID As Long = 0
	Private internalIMs(0) As ContactIM
	Private internalNicknames(0) As ContactNickname
	Private internalNote As String = ""
	Private internalOrganizations(0) As ContactOrganization
	Private internalPhoneNumbers(0) As ContactPhoneNumber
	Private internalRelations(0) As ContactRelation
	Private internalSipAddresses(0) As ContactSipAddress
	Private internalStarred As Boolean = False
	Private internalStructuredName As ContactStructuredName
	Private internalThumbnailPhoto As Bitmap = Null
	Private internalWebsites(0) As ContactWebsite
End Sub

'This will initialize this ContactItemSnapshot instance with the given ContactItem
'contact - must be a valid ContactItem instance or NULL for an empty ContactItemSnapshot instance.
Public Sub Initialize'(contact As ContactItem)
'	'internalContactItem = contact
'	If contact <> Null Then
'		internalAddresses = contact.Addresses
'		internalEMailAddresses = contact.EMailAddresses
'		internalEvents = contact.Events
'		internalID = contact.ID
'		internalIMs = contact.IMs
'		internalNicknames = contact.Nicknames
'		internalNote = contact.Note
'		internalOrganizations = contact.Organizations
'		internalPhoneNumbers = contact.PhoneNumbers
'		internalRelations = contact.Relations
'		internalSipAddresses = contact.SipAddresses
'		internalStarred = contact.Starred
'		internalStructuredName = contact.StructuredName
'		internalWebsites = contact.Websites
'		internalThumbnailPhoto = contact.ThumbnailPhoto
'	End If
End Sub

Public Sub getAddresses As ContactAddress()
	Return internalAddresses
End Sub

'This will clear this ContactItemSnapshot instance.
Public Sub Clear
	internalID = 0
	internalStarred = False
	internalNote = ""
	internalThumbnailPhoto = Null
	
	Dim addresses(0) As ContactAddress
	internalAddresses = addresses
	Dim emailAddresses(0) As ContactEmailAddress
	internalEMailAddresses = emailAddresses
	Dim events(0) As ContactEvent
	internalEvents = events
	Dim ims(0) As ContactIM
	internalIMs = ims
	Dim nicknames(0) As ContactNickname
	internalNicknames = nicknames
	Dim organizations(0) As ContactOrganization
	internalOrganizations = organizations
	Dim phoneNumbers(0) As ContactPhoneNumber
	internalPhoneNumbers = phoneNumbers
	Dim relations(0) As ContactRelation
	internalRelations = relations
	Dim sipAddresses(0) As ContactSipAddress
	internalSipAddresses = sipAddresses
	Dim structuredName As ContactStructuredName
	internalStructuredName = structuredName
	Dim websites(0) As ContactWebsite
	internalWebsites = websites
End Sub

Public Sub getEMailAddresses As ContactEmailAddress()
	Return internalEMailAddresses
End Sub

Public Sub getEvents As ContactEvent()
	Return internalEvents
End Sub

Public Sub getDisplayName As String
	Dim resultDisplayName As String = ""
	If internalStructuredName.IsInitialized Then
		resultDisplayName = internalStructuredName.DisplayName
	End If
	Return resultDisplayName
End Sub

Public Sub getID As Long
	Return internalID
End Sub

Public Sub getIMs As ContactIM()
	Return internalIMs
End Sub

'This will return true if this ContactItemSnapshot class instance was empty, otherwise false will be returned.
Public Sub getIsEmpty As Boolean
	Dim resultIsEmpty As Boolean
	Dim checkValue As Int
	checkValue = checkValue + internalID
	checkValue = checkValue + internalAddresses.Length + internalEMailAddresses.Length + internalEvents.Length
	checkValue = checkValue + internalIMs.Length + internalNicknames.Length + internalNote.Length
	checkValue = checkValue + internalOrganizations.Length + internalPhoneNumbers.Length + internalRelations.Length
	checkValue = checkValue + internalSipAddresses.Length + internalWebsites.Length
	If internalStructuredName.IsInitialized Then
		checkValue = checkValue + 1
	End If
	If internalThumbnailPhoto.IsInitialized Then
		checkValue = checkValue + 1
	End If
	If checkValue = 0 Then
		resultIsEmpty = True
	Else
		resultIsEmpty = False
	End If
	Return resultIsEmpty
End Sub

Public Sub getNicknames As ContactNickname()
	Return internalNicknames
End Sub

Public Sub getNote As String
	Return internalNote
End Sub

Public Sub getOrganizations As ContactOrganization()
	Return internalOrganizations
End Sub

Public Sub getPhoneNumbers As ContactPhoneNumber()
	Return internalPhoneNumbers
End Sub

Public Sub getRelations As ContactRelation()
	Return internalRelations
End Sub

Public Sub getSipAddresses As ContactSipAddress()
	Return internalSipAddresses
End Sub

Public Sub getStarred As Boolean
	Return internalStarred
End Sub

Public Sub getStructuredName As ContactStructuredName
	Return internalStructuredName
End Sub

Public Sub TakeSnapshotFrom(contact As ContactItem)
	internalAddresses = contact.Addresses
	internalEMailAddresses = contact.EMailAddresses
	internalEvents = contact.Events
	internalID = contact.ID
	internalIMs = contact.IMs
	internalNicknames = contact.Nicknames
	internalNote = contact.Note
	internalOrganizations = contact.Organizations
	internalPhoneNumbers = contact.PhoneNumbers
	internalRelations = contact.Relations
	internalSipAddresses = contact.SipAddresses
	internalStarred = contact.Starred
	internalStructuredName = contact.StructuredName
	internalWebsites = contact.Websites
	internalThumbnailPhoto = contact.ThumbnailPhoto
End Sub

Public Sub getThumbnailPhoto As Bitmap
	Return internalThumbnailPhoto
End Sub

Public Sub getWebsites As ContactWebsite()
	Return internalWebsites
End Sub

'This will read a binary stored contact from the given inputstream into this ContactItemSnapshot class instance.
'input - must be a valid readable inputstream
Public Sub ReadFrom(input As InputStream)
	If getIsEmpty = False Then
		Clear
	End If
	Dim reader As ByteStreamReader
	reader.Initialize(input)
	internalStructuredName.Initialize
	CallSub2(internalStructuredName, "ReadFrom", reader)
	internalStarred = reader.ReadBoolean
	Dim contentID As Int = 1
	Do While contentID > 0
		contentID = reader.ReadInt
		Log("Content ID: " & contentID)
		If contentID > 0 Then
			If contentID = 1 Then
				Dim addresses(reader.ReadInt) As ContactAddress
				For index = 0 To addresses.Length - 1
					addresses(index).Initialize
				Next
				ReadEntriesFrom(addresses, reader)
				internalAddresses = addresses
			Else If contentID = 2 Then
				Dim emailAddresses(reader.ReadInt) As ContactEmailAddress
				For index = 0 To emailAddresses.Length - 1
					emailAddresses(index).Initialize
				Next
				ReadEntriesFrom(emailAddresses, reader)
				internalEMailAddresses = emailAddresses
			Else if contentID = 3 Then
				Dim events(reader.ReadInt) As ContactEvent
				For index = 0 To events.Length - 1
					events(index).Initialize
				Next
				ReadEntriesFrom(events, reader)
				internalEvents = events
			Else If contentID = 4 Then
				Dim ims(reader.ReadInt) As ContactIM
				For index = 0 To ims.Length - 1
					ims(index).Initialize
				Next
				ReadEntriesFrom(ims, reader)
				internalIMs = ims
			Else If contentID = 5 Then
				Dim nicknames(reader.ReadInt) As ContactNickname
				For index = 0 To nicknames.Length - 1
					nicknames(index).Initialize
				Next
				ReadEntriesFrom(nicknames, reader)
				internalNicknames = nicknames
			Else If contentID = 6 Then
				internalNote = reader.ReadString
			Else If contentID = 7 Then
				Dim organizations(reader.ReadInt) As ContactOrganization
				For index = 0 To organizations.Length - 1
					organizations(index).Initialize
				Next
				ReadEntriesFrom(organizations, reader)
				internalOrganizations = organizations
			Else If contentID = 8 Then
				Dim phoneNumbers(reader.ReadInt) As ContactPhoneNumber
				For index = 0 To phoneNumbers.Length - 1
					phoneNumbers(index).Initialize
				Next
				ReadEntriesFrom(phoneNumbers, reader)
				internalPhoneNumbers = phoneNumbers
			Else If contentID = 9 Then
				Dim relations(reader.ReadInt) As ContactRelation
				For index = 0 To relations.Length - 1
					relations(index).Initialize
				Next
				ReadEntriesFrom(relations, reader)
				internalRelations = relations
			Else If contentID = 10 Then
				Dim sipAddresses(reader.ReadInt) As ContactSipAddress
				For index = 0 To sipAddresses.Length - 1
					sipAddresses(index).Initialize
				Next
				ReadEntriesFrom(sipAddresses, reader)
				internalSipAddresses = sipAddresses
			Else If contentID = 11 Then
				Dim websites(reader.ReadInt) As ContactWebsite
				For index = 0 To websites.Length - 1
					websites(index).Initialize
				Next
				ReadEntriesFrom(websites, reader)
				internalWebsites = websites
			Else If contentID = 100 Then
				Dim thumbnailBitmap As Bitmap
				thumbnailBitmap = reader.ReadBitmap
				internalThumbnailPhoto = thumbnailBitmap
			Else
				Log("Unknown content! Content ID: " & contentID)
				Exit
			End If	
		End If
		Log("Done.")
	Loop
End Sub

Private Sub ReadEntriesFrom(entries() As Object, reader As ByteStreamReader)
	For index = 0 To entries.Length - 1
		CallSub2(entries(index), "ReadFrom", reader)
	Next
End Sub

'This will store all entries of this ContactItemSnapshot class instance, without the id, binary into the given outputstream.
'out - Must be a valid writeable outputstream 
Public Sub WriteTo(out As OutputStream)
	Dim writer As ByteStreamWriter
	writer.Initialize(out)
	CallSub2(internalStructuredName, "WriteTo", writer)
	writer.WriteBoolean(internalStarred)
	If internalAddresses.Length > 0 Then
		writer.WriteInt(1) 'The content id
		WriteEntriesTo(internalAddresses, writer)	
	End If
	If internalEMailAddresses.Length > 0 Then 
		writer.WriteInt(2) 'The content id
		WriteEntriesTo(internalEMailAddresses, writer)
	End If
	If internalEvents.Length > 0 Then 
		writer.WriteInt(3) 'The content id
		WriteEntriesTo(internalEvents, writer)
	End If
	If internalIMs.Length > 0 Then
		writer.WriteInt(4) 'The content id
		WriteEntriesTo(internalIMs, writer)
	End If
	If internalNicknames.Length > 0 Then
		writer.WriteInt(5)
		WriteEntriesTo(internalNicknames, writer)
	End If
	If internalNote.Length > 0 Then
		writer.WriteInt(6)
		writer.WriteString(internalNote)
	End If
	If internalOrganizations.Length > 0 Then 
		writer.WriteInt(7) 'The content id
		WriteEntriesTo(internalOrganizations, writer)
	End If
	If internalPhoneNumbers.Length > 0 Then 
		writer.WriteInt(8) 'The content id
		WriteEntriesTo(internalPhoneNumbers, writer)
	End If
	If internalRelations.Length > 0 Then
		writer.WriteInt(9) 'The content id
		WriteEntriesTo(internalRelations, writer)
	End If
	If internalSipAddresses.Length > 0 Then
		writer.WriteInt(10) 'The content id
		WriteEntriesTo(internalSipAddresses, writer)
	End If
	If internalWebsites.Length > 0 Then
		writer.WriteInt(11) 'The content id
		WriteEntriesTo(internalWebsites, writer)
	End If
	If internalThumbnailPhoto.IsInitialized Then
		writer.WriteInt(100)
		writer.WriteBitmap(internalThumbnailPhoto)
	End If
	writer.WriteInt(0)
End Sub

Private Sub WriteEntriesTo(entries() As Object, writer As ByteStreamWriter)
	writer.WriteInt(entries.Length)
	For index = 0 To entries.Length - 1
		CallSub2(entries(index), "WriteTo", writer)
	Next
End Sub