﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'ContactNickname Class module
Private Sub Class_Globals
	Private internalLabel As String
	Private internalName As String
	Private internalTyp As String
End Sub

'This will initialize this contact nickname entry with the default typ(e).
Public Sub Initialize
	Clear
	'internalTyp = ContactStatics.NicknameTypes.Get("1")
End Sub

Public Sub Clear
	internalLabel = ""
	internalName = ""
	internalTyp = ContactStatics.NicknameTypes.Get("1")
End Sub

'This will get/set the label of this entry. By default this field is null or empty.
'- The typ(e) of this entry must be set to custom to use the label.
Public Sub getLabel As String
	Return internalLabel
End Sub

Public Sub setLabel(label As String)
	internalLabel = label
End Sub

'This will get/set the nick name.
Public Sub getName As String
	Return internalName
End Sub

Public Sub setName(name As String)
	internalName = name
End Sub

'This is only for internal use!
Private Sub Parse(data() As Object)
	internalName = data(0)
	internalTyp = ContactStatics.NicknameTypes.Get(data(1))
	internalLabel = data(2)
End Sub

'This is only for internal use!
Private Sub ToDataArray As Object()
	Dim data(3) As Object
	data(0) = internalName
	data(1) = ContactStatics.GetKeyFromValue(ContactStatics.NicknameTypes, internalTyp, "1")
	data(2) = internalLabel
	Return data
End Sub

'This will get/set the typ(e) of this entry.
'- On custom typ(e) the label must be filled up.
'- Valid types for this field can be found in ContactStatics.NicknameTypes map.
Public Sub getTyp As String
	Return internalTyp
End Sub

Public Sub setTyp(typ As String)
	Dim typeExists As Boolean = ContactStatics.HasValue(ContactStatics.NicknameTypes, typ)
	If typeExists Then
		internalTyp = typ.ToLowerCase
	Else
		LogColor("ContactNickname->Typ: The type '" & typ & "' was unknown by this class!", Colors.Red)
	End If
End Sub

Private Sub ReadFrom(reader As ByteStreamReader)
	Dim data(3) As Object
	data(0) = reader.ReadString
	data(1) = "" & reader.ReadInt
	data(2) = reader.ReadString
	Parse(data)
End Sub

Private Sub WriteTo(writer As ByteStreamWriter)
	Dim data() As Object = ToDataArray
	writer.WriteString(data(0))
	writer.WriteInt(data(1))
	writer.WriteString(data(2))
End Sub