﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'ContactOrganization Class module
Private Sub Class_Globals
	Private internalCompany As String = ""
	Private internalDepartment As String = ""
	Private internalJobDescription As String = ""
	Private internalLabel As String = ""
	Private internalOfficeLocation As String = ""
	Private internalPhoneticName As String = ""
	Private internalPhoneticNameStyle As String = ""
	Private internalSymbol As String = ""
	Private internalTitle As String = ""
	Private internalTyp As String = ""
End Sub

'This will initialize this contact organization class object with the default typ(e).
Public Sub Initialize
	internalTyp = ContactStatics.OrganizationTypes.Get("1")
End Sub

Public Sub Clear
	internalCompany = ""
	internalTyp = ContactStatics.OrganizationTypes.Get("1")
	internalLabel = ""
	internalTitle = ""
	internalDepartment = ""
	internalJobDescription = ""
	internalSymbol = ""
	internalPhoneticName = ""
	internalOfficeLocation = ""
	internalPhoneticNameStyle = ""
End Sub

'This will get/set the company name.
Public Sub getCompany As String
	Return internalCompany
End Sub

Public Sub setCompany(company As String)
	internalCompany = company
End Sub

'This will get/set the department.
Public Sub getDepartment As String
	Return internalDepartment
End Sub

Public Sub setDepartment(department As String)
	internalDepartment = department
End Sub

'This will get/set the job description.
Public Sub getJobDescription As String
	Return internalJobDescription
End Sub

Public Sub setJobDescription(jobDescription As String)
	internalJobDescription = jobDescription
End Sub

'This will get/set the label.
'- typ(e) should be set to custom to use the label field.
Public Sub getLabel As String
	Return internalLabel
End Sub

Public Sub setLabel(label As String)
	internalLabel = label
End Sub

'This will get/set the office location.
Public Sub getOfficeLocation As String
	Return internalOfficeLocation
End Sub

Public Sub setOfficeLocation(officeLocation As String)
	internalOfficeLocation = officeLocation
End Sub

'This is for internal use only!
Private Sub Parse(data() As Object)
	internalCompany = data(0)
	internalTyp = ContactStatics.OrganizationTypes.Get(data(1))
	internalLabel = data(2)
	internalTitle = data(3)
	internalDepartment = data(4)
	internalJobDescription = data(5)
	internalSymbol = data(6)
	internalPhoneticName = data(7)
	internalOfficeLocation = data(8)
	internalPhoneticNameStyle = data(9)
End Sub

'This will get/set the phonetic name.
Public Sub getPhoneticName As String
	Return internalPhoneticName
End Sub

Public Sub setPhoneticName(phoneticName As String)
	internalPhoneticName = phoneticName
End Sub

'This will get/set the phonetic name style.
Public Sub getPhoneticNameStyle As String
	Return internalPhoneticNameStyle
End Sub

Public Sub setPhoneticNameStyle(phoneticNameStyle As String)
	internalPhoneticNameStyle = phoneticNameStyle
End Sub

'This will get/set the symbol.
Public Sub getSymbol As String
	Return internalSymbol
End Sub

Public Sub setSymbol(symbol As String)
	internalSymbol = symbol
End Sub

'This will get/set the title.
Public Sub getTitle As String
	Return internalTitle
End Sub

Public Sub setTitle(title As String)
	internalTitle = title
End Sub

'This is for internal use only!
Private Sub ToDataArray As Object()
	Dim data(10) As Object
	data(0) = internalCompany
	data(1) = ContactStatics.GetKeyFromValue(ContactStatics.OrganizationTypes, internalTyp, "1")
	data(2) = internalLabel
	data(3) = internalTitle
	data(4) = internalDepartment
	data(5) = internalJobDescription
	data(6) = internalSymbol
	data(7) = internalPhoneticName
	data(8) = internalOfficeLocation
	data(9) = internalPhoneticNameStyle
	Return data
End Sub

'This will get/set the typ(e).
'- Valid types can be found in ContactStatics.OrganizationTypes map.
'- To set your own label set the typ(e) to custom value.
Public Sub getTyp As String
	Return internalTyp
End Sub

Public Sub setTyp(typ As String)
	Dim typeExists As Boolean = ContactStatics.HasValue(ContactStatics.OrganizationTypes, typ)
	If typeExists Then
		internalTyp = typ.ToLowerCase
	Else
		LogColor("ContactOrganization->Typ: The type '" & typ & "' was unknown by this class!", Colors.Red)
	End If
End Sub

Private Sub ReadFrom(reader As ByteStreamReader)
	Dim data(10) As Object
	data(0) = reader.ReadString
	data(1) = "" & reader.ReadInt
	For index = 2 To data.Length - 1
		data(index) = reader.ReadString
	Next
	Parse(data)
End Sub

Private Sub WriteTo(writer As ByteStreamWriter)
	Dim data() As Object = ToDataArray
	writer.WriteString(data(0))
	writer.WriteInt(data(1))
	For index = 2 To data.Length - 1
		writer.WriteString(data(index))
	Next
End Sub