﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'ContactPhoneNumber Class module
Private Sub Class_Globals
	Private internalIsPrimary As Boolean = False
	Private internalLabel As String = "" 'DATA3
	Private internalNumber As String = "" 'DATA1
	Private internalTyp As String = "" 'DATA2
End Sub

'This will initialize this contactphonenumber class with the default typ(e).
Public Sub Initialize
	internalTyp = ContactStatics.PhoneNumberTypes.Get("1")
End Sub

'This will return true if this phone number is the primary phone number of the contact, otherwise false will be returned.
Public Sub getIsPrimary As Boolean
	 Return internalIsPrimary
End Sub

'This will get/set the label of the phone number entry.
'- The typ of the phone number must be set to custom otherwise the label should be empty
Public Sub getLabel As String
	Return internalLabel
End Sub

Public Sub setLabel(label As String)
	internalLabel = label
End Sub

'This will get/set the phone number.
Public Sub getNumber As String
	Return internalNumber
End Sub

Public Sub setNumber(number As String)
	internalNumber = number
End Sub

'This is for internal use only.
Private Sub Parse(data() As Object, primary As Boolean)
	internalNumber = data(0)
	internalTyp = ContactStatics.PhoneNumberTypes.Get(data(1))
	internalLabel = data(2)
	internalIsPrimary = primary
End Sub

'This is for internal use only.
Private Sub ToDataArray As Object()
	Dim data(3) As Object
	data(0) = internalNumber
	data(1) = ContactStatics.GetKeyFromValue(ContactStatics.PhoneNumberTypes, internalTyp, 1)
	data(2) = internalLabel
	Return data
End Sub

'This will get/set the phone number type.
'- The valid values you will find in ContactStatics.PhoneNumberTypes map.
'- To use the label set the typ(e) to custom.
Public Sub getTyp As String
	Return internalTyp
End Sub

Public Sub setTyp(typ As String)
	Dim typeExists As Boolean = ContactStatics.HasValue(ContactStatics.PhoneNumberTypes, typ)
	If typeExists Then
		internalTyp = typ.ToLowerCase
	Else
		LogColor("ContactPhoneNumber->Typ: The type '" & typ & "' was unknown by this class!", Colors.Red)
	End If
End Sub

Private Sub ReadFrom(reader As ByteStreamReader)
	Dim isPrimary As Boolean
	Dim data(3) As Object
	data(0) = reader.ReadString
	data(1) = "" & reader.ReadInt
	data(2) = reader.ReadString
	isPrimary = reader.ReadBoolean
	Parse(data, isPrimary)
End Sub

Private Sub WriteTo(writer As ByteStreamWriter)
	Dim data() As Object = ToDataArray
	writer.WriteString(data(0))
	writer.WriteInt(data(1))
	writer.WriteString(data(2))
	writer.WriteBoolean(internalIsPrimary)
End Sub