﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'ContactRelation Class module
Private Sub Class_Globals
	Private internalLabel As String
	Private internalName As String
	Private internalTyp As String
End Sub

'This will initialize this contact relation class object with the default typ(e).
Public Sub Initialize
	Clear
	'internalTyp = ContactStatics.RelationTypes.Get("1")
End Sub

'This will clear this class structure.
Public Sub Clear
	internalLabel = ""
	internalName = ""
	internalTyp = ContactStatics.RelationTypes.Get("1")
End Sub

'This will get/set the label of this class object.
'- The type(e) must be set to custom for a correct use.
Public Sub getLabel As String
	Return internalLabel
End Sub

Public Sub setLabel(label As String)
	internalLabel = label
End Sub

'This will get/set the name.
Public Sub getName As String
	Return internalName
End Sub

Public Sub setName(name As String)
	internalName = name
End Sub

'This is for internal use only!
Private Sub Parse(data() As Object)
	internalName = data(0)
	internalTyp = ContactStatics.RelationTypes.Get(data(1))
	internalLabel = data(2)
End Sub

'This is for internal use only!
Private Sub ToDataArray As Object()
	Dim data(3) As Object
	data(0) = internalName
	data(1) = ContactStatics.GetKeyFromValue(ContactStatics.RelationTypes, internalTyp, 1)
	data(2) = internalLabel
	Return data
End Sub

'This will get/set the typ(e).
'- Valid values for this class object can be found in ContactStatics.RelationTypes map.
'- To use the label in a correct way, set this typ(e) to custom.
Public Sub getTyp As String
	Return internalTyp
End Sub

Public Sub setTyp(typ As String)
	internalTyp = typ
End Sub

Private Sub ReadFrom(reader As ByteStreamReader)
	Dim data(3) As Object
	data(0) = reader.ReadString
	data(1) = "" & reader.ReadInt
	data(2) = reader.ReadString
	Parse(data)
End Sub

Private Sub WriteTo(writer As ByteStreamWriter)
	Dim data() As Object = ToDataArray
	writer.WriteString(data(0))
	writer.WriteInt(data(1))
	writer.WriteString(data(2))
End Sub