﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'ContactSipAddress Class module
Private Sub Class_Globals
	Private internalLabel As String
	Private internalSipAddress As String
	Private internalTyp As String
End Sub

'This will initialize this contact sip address class object with the default typ(e).
Public Sub Initialize
	Clear
	'internalTyp = ContactStatics.SipAddressTypes.Get("1")
End Sub

Public Sub Clear
	internalLabel = ""
	internalSipAddress = ""
	internalTyp = ContactStatics.SipAddressTypes.Get("1")
End Sub

'This will get/set the label.
'- To use the label set the typ(e) to custom value.
Public Sub getLabel As String
	Return internalLabel
End Sub

Public Sub setLabel(label As String)
	internalLabel = label
End Sub

'This is for internal use only!
Private Sub Parse(data() As Object)
	internalSipAddress = data(0)
	internalTyp = ContactStatics.SipAddressTypes.Get(data(1))
	internalLabel = data(2)
End Sub

'This will get/set the sip address.
Public Sub getSipAddress As String
	Return internalSipAddress
End Sub

Public Sub setSipAddress(sipAddress As String)
	internalSipAddress = sipAddress
End Sub

'This is for internal use only!
Private Sub ToDataArray As Object()
	Dim data(3) As Object
	data(0) = internalSipAddress
	data(1) = ContactStatics.GetKeyFromValue(ContactStatics.SipAddressTypes, internalTyp, "1")
	data(2) = internalLabel
	Return data
End Sub

'This will get/set the typ(e).
'- Valid types can be found under ContactStatics.SipAddressTypes map.
'- To use the label set the typ(e) to custom type value.
Public Sub getTyp As String
	Return internalTyp
End Sub

Public Sub setTyp(typ As String)
	Dim typeExists As Boolean = ContactStatics.HasValue(ContactStatics.RelationTypes, typ)
	If typeExists Then
		internalTyp = typ.ToLowerCase
	Else
		LogColor("ContactRelation->Typ: The type '" & typ & "' was unknown by this class!", Colors.Red)
	End If
End Sub

Private Sub ReadFrom(reader As ByteStreamReader)
	Dim data(3) As Object
	data(0) = reader.ReadString
	data(1) = "" & reader.ReadInt
	data(2) = reader.ReadString
	Parse(data)
End Sub

Private Sub WriteTo(writer As ByteStreamWriter)
	Dim data() As Object = ToDataArray
	writer.WriteString(data(0))
	writer.WriteInt(data(1))
	writer.WriteString(data(2))
End Sub