﻿Type=Class
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'ContactStructuredName Class module
Private Sub Class_Globals
	Private internalDisplayName As String 'Anzeigename
	Private internalFamilyName As String 'Nachname
	Private internalFullNameStyle As String
	Private internalGivenName As String 'Vorname
	Private internalMiddleName As String 'Mittelname
	Private internalPhoneticFamilyName As String
	Private internalPhoneticGivenName As String
	Private internalPhoneticMiddleName As String
	Private internalPrefix As String 'Mr. Mrs. Dr.
	Private internalSuffix As String 'Jr. Sr.
End Sub

'This will initialize the contact structured name class object with the default fullnamestyle.
Public Sub Initialize
	Clear
	'internalFullNameStyle = ContactStatics.FullNameStyles.Get("1")
End Sub

Public Sub Clear
	internalDisplayName = ""
	internalFamilyName = ""
	internalFullNameStyle = ContactStatics.FullNameStyles.Get("1")
	internalGivenName = ""
	internalMiddleName = ""
	internalPhoneticFamilyName = ""
	internalPhoneticGivenName = ""
	internalPhoneticMiddleName = ""
	internalPrefix = ""
	internalSuffix = ""
End Sub

'This will get/set the display name.
'- The display name will be set automaticly by the system out of the other fields of this class.
Public Sub getDisplayName As String
	Return internalDisplayName
End Sub

Public Sub setDisplayName(displayName As String)
	internalDisplayName = displayName
End Sub

'This will get/set the family name.
Public Sub getFamilyName As String
	Return internalFamilyName
End Sub

Public Sub setFamilyName(familyName As String)
	internalFamilyName = familyName
End Sub

'This will get/set the full name style.
'- Valid values can be found in ContactStatics.FullNameStyles map.
Public Sub getFullNameStyle As String
	Return internalFullNameStyle
End Sub

Public Sub setFullNameStyle(fullNameStyle As String)
	Dim styleExists As Boolean = ContactStatics.HasValue(ContactStatics.FullNameStyles, fullNameStyle)
	If styleExists Then
		internalFullNameStyle = fullNameStyle.ToLowerCase
	Else
		LogColor("ContactStructuredName->FullNameStyle: The full name style '" & fullNameStyle & "' was unknown by this class!", Colors.Red)
	End If
End Sub

'This will get/set the given name.
Public Sub getGivenName As String
	Return internalGivenName
End Sub

Public Sub setGivenName(givenName As String)
	internalGivenName = givenName
End Sub

'This will get/set the middle name.
Public Sub getMiddleName As String
	Return internalMiddleName
End Sub

Public Sub setMiddleName(middleName As String)
	internalMiddleName = middleName
End Sub

'This is for internal use only! Use it with safty.
Private Sub Parse(data() As Object)
	internalDisplayName = data(0)
	internalGivenName = data(1)
	internalFamilyName = data(2)
	internalPrefix = data(3)
	internalMiddleName = data(4)
	internalSuffix = data(5)
	internalPhoneticGivenName = data(6)
	internalPhoneticMiddleName = data(7)
	internalPhoneticFamilyName = data(8)
	internalFullNameStyle = ContactStatics.FullNameStyles.Get(data(9))
End Sub

'This will get/set the phonetic family name.
Public Sub getPhoneticFamilyName As String
	Return internalPhoneticFamilyName
End Sub

Public Sub setPhoneticFamilyName(phoneticFamilyName As String)
	internalPhoneticFamilyName = phoneticFamilyName
End Sub

'This will get/set the phonetic given name.
Public Sub getPhoneticGivenName As String
	Return internalPhoneticGivenName
End Sub

Public Sub setPhoneticGivenName(phoneticGivenName As String)
	internalPhoneticGivenName = phoneticGivenName
End Sub

'This will get/set the phonetic middle name.
Public Sub getPhoneticMiddleName As String
	Return internalPhoneticMiddleName
End Sub

Public Sub setPhoneticMiddleName(phoneticMiddleName As String)
	internalPhoneticMiddleName = phoneticMiddleName
End Sub

'This will get/set the prefix.
Public Sub getPrefix As String
	Return internalPrefix
End Sub

Public Sub setPrefix(prefix As String)
	internalPrefix = prefix
End Sub

'This will get/set the suffix
Public Sub getSuffix As String
	Return internalSuffix
End Sub

Public Sub setSuffix(suffix As String)
	internalSuffix = suffix
End Sub

'This is for internal use only!
Private Sub ToDataArray As Object()
	Dim data(10) As Object
	data(0) = internalDisplayName
	data(1) = internalGivenName
	data(2) = internalFamilyName
	data(3) = internalPrefix
	data(4) = internalMiddleName
	data(5) = internalSuffix
	data(6) = internalPhoneticGivenName
	data(7) = internalPhoneticMiddleName
	data(8) = internalPhoneticFamilyName
	data(9) = ContactStatics.GetKeyFromValue(ContactStatics.FullNameStyles, internalFullNameStyle, "1")
	Return data
End Sub

Private Sub ReadFrom(reader As ByteStreamReader)
	Dim data(10) As Object
	For index = 0 To data.Length - 2
		data(index) = reader.ReadString
	Next
	data(9) = "" & reader.ReadInt
	Parse(data)
End Sub

Private Sub WriteTo(writer As ByteStreamWriter)
	Dim data() As Object = ToDataArray
	For index = 0 To data.Length - 2
		writer.WriteString(data(index))
	Next
	writer.WriteInt(data(data.Length - 1))
End Sub